"use strict";

var Modul_dwdopendataheadline = function () {

    function init() {
        me.elements = $('div[data-type="' + me.widgetname + '"]:not([data-ready])', me.area);
        me.elements.each(function (index) {
            var elem = $(this);
            elem.attr("data-ready", "");
            
			elem.initData('max',			10);
			elem.initData('a_count',		'a_count');

			// if hide reading is defined, set defaults for comparison
			if (elem.isValidData('hide')) {
				elem.initData('hide-on', 'true|1|on');
			}
			elem.initData('hide', elem.data('a_count'));
			if (elem.isValidData('hide-on')) {
				elem.initData('hide-off', '!on');
			}
			me.addReading(elem, 'hide');
			me.addReading(elem, 'a_count');
			
			var count = elem.getReading('a_count').val;
			if (count >= 1) {
				if (count > elem.data('max')) {
					count = elem.data('max');
				}
				for (var i = 0; i <= count - 1; i++) {

					elem.initData('a_' + i + '_areaColor', 'a_' + i + '_areaColor');
					me.addReading(elem, 'a_' + i + '_areaColor');
					elem.initData('a_' + i + '_urgency', 'a_' + i + '_urgency');
					me.addReading(elem, 'a_' + i + '_urgency');
					elem.initData('a_' + i + '_eventDesc', 'a_' + i + '_eventDesc');
					me.addReading(elem, 'a_' + i + '_eventDesc');
				}
			}
        });
    }
	
	function update(dev,par) {
		
		me.elements.filter('div[data-device="' + dev + '"]')
        .each(function (index) {
			var elem = $(this);
			var html = "";
			var count = elem.getReading('a_count').val;
			if (count >= 1) {
				if (count > elem.data('max')) {
					count = elem.data('max');
				}
				for (var i = 0; i <= count - 1; i++) {
					html += "<div class=\"top-space\">";
					
					if (elem.getReading('a_' + i + '_urgency').val == "Immediate") {
						html += "<div class=\"\" style=\"min-width:150px;display:inline-block;padding:4px;font-weight:bold;color:#222222;border-radius:4px;background-color:rgb(" + elem.getReading('a_' + i + '_areaColor').val + ");\"><i class=\"fa fa-exclamation-triangle\" style=\"color:firebrick;\"></i>&nbsp;" + elem.getReading('a_' + i + '_eventDesc').val + "&nbsp;<i class=\"fa fa-exclamation-triangle\" style=\"color:firebrick;\"></i></div>";
					}
					else if (elem.getReading('a_' + i + '_urgency').val == "Future") {
						html += "<div class=\"\" style=\"min-width:150px;display:inline-block;padding:4px;font-weight:bold;color:#222222;border-radius:4px;background-color:rgb(" + elem.getReading('a_' + i + '_areaColor').val + ");\"><i class=\"fa fa-info-circle\" style=\"color:#0088CC;\"></i>&nbsp;" + elem.getReading('a_' + i + '_eventDesc').val + "&nbsp;<i class=\"fa fa-exclamation-triangle\" style=\"color:#0088CC;\"></i></div>";
					}
					html += "</div>";
				}
			}
			else {
				html += "<div class=\"top-space\" style=\"min-width:150px;display:inline-block;padding:3px;color:#DDDDDD;border-radius:4px;background-color:#32A054;\">Aktuell keine Warnmeldungen vorhanden.</div>";
			}
			elem.html(html);
			//extra reading for hide
			me.update_hide(dev, par);
		});
	}

    // public
    // inherit all public members from base class
    var me = $.extend(new Modul_widget(), {
        //override or own public members
        widgetname: 'dwdopendataheadline',
        init: init,
		update: update,
    });
    return me;
};