/* FTUI Plugin

*/

function depends_pinpad(){
	 $('head').append('<link rel="stylesheet" href="' + ftui.config.basedir + 'lib/pinpad.css" type="text/css" />');
}

var Modul_pinpad = function(){

	function init(){

		me.elements = $('div[data-type="' + me.widgetname + '"]', me.area);
		me.elements.each(function (index) {

			function createPad(elem){

				var pad = $("<div></div>");
				pad.attr("id", "pinpad");
				pad.css({
					"background": elem.data("bg-color"),
					"box-shadow": "4px 4px 8px "+ elem.data("shadow-color") +"",
					"width": elem.data("width"),
					"height": elem.data("height")
				});
				elem.append(pad);

				var input = $("<div></div>");
				input.attr("id", "input-pinpad");
				pad.append(input);

				var message = $("<p></p>");
				message.attr("id", "pinpad-text");
				$("#pinpad").append(message);
				if (elem.getReading("get").val === "off"){
					message.css({
						"color": elem.data("unlocked-color")
					});
				}
				else{
					message.css({
						"color": elem.data("locked-color")
					});
				}

				var btns = $("<div></div>");
				btns.attr("id", "pinpad-btns");
				pad.append(btns);

				// creating numbers on pinpad
				for (var i = 1; i < 10; i++){
					var div = $("<div>"+ i +"</div>");
					div.attr("id", i);
					div.attr("class", "number-pinpad num-click");
					btns.append(div);
				}
				function lastLine(elem){
					var back = $("<div></div>");
					back.attr("id", "back");
					back.attr("class", "fa fa-angle-left number-pinpad");
					btns.append(back);

					var zero = $("<div>0</div>");
					zero.attr("id", "zero");
					zero.attr("class", "number-pinpad num-click");
					btns.append(zero);

					var key = $("<div></div>");
					key.attr("id", "key-pinpad");
					key.attr("class", "fa "+ elem.data("icon") +" number-pinpad");
					btns.append(key);
				}lastLine(elem);
			}

            var elem = $(this);
            elem.initData('device', ' ');
	        elem.initData('get-pin', 'pin');
	        elem.initData("get", "state");
	        elem.initData("width", "300px");
	        elem.initData("height", "450px");
	        elem.initData("icon", "fa-key");
	        elem.initData("set", "");

	            //customitable colors
	        elem.initData("locked-color", "#c60000");
	        elem.initData("unlocked-color", "#56e20b");
	       	elem.initData("button-color", "white");
	        elem.initData("bg-color", "#565656");
	        elem.initData("shadow-color", "rgba(0,0,0,.3)");
	        elem.initData("pin-off-color", "grey");
	        elem.initData("pin-on-color", "#cccccc");
	        elem.initData("text-unlocked", "Unlocked");
	        elem.initData("text-locked", "Locked");
	        elem.initData("locked-time", "10");
	        elem.initData("tries", "5");
	        elem.initData("btn-size", "70px");
	        elem.initData("font-size", "40px");


	        // subscripe my readings for updating
	        me.addReading(elem, 'get-pin');
	        me.addReading(elem, "get");
            // creating the pinpad
            createPad(elem);
        });
	}

	function event_handler(elem){
		//false pin countdown timer
		var falseCounter = 0;
		function startTimer(){
			$(".number-pinpad").css({
				"pointer-events": "none"
			});
			var counter = elem.data("locked-time");
			var timer = setInterval(function(){
				counter --;
				if(counter >= 0){
					$("#pinpad-text").html("Locked for: "+ counter);
				}

				if (counter <= 0){
					$("#pinpad-text").html(elem.data("text-locked"));
					$(".number-pinpad").css({
						"pointer-events": "auto"
					});
					falseCounter = 0;
					clearInterval(timer);
				}
			}, 1000);
		}
		//pinpad click events
		var insertedPin ="";
        var counter = 0;
        $(".num-click").on("click", function(){
          	var num = $(this).index() + 1
           	insertedPin += num;
           	counter++;
           	if (elem.hasClass("show-pin")){
           		updateDot(elem, insertedPin);
           	}
           	else{
           		$(".dots-pinpad:nth-child("+ counter +")").css({
					"background": elem.data("pin-on-color"),
					"transition": "all .5s cubic-bezier(0,1,.5,1)",
					"transform": "scale(1)"
				});
           	}
			if (counter === elem.getReading("get-pin").val.length){
				if(insertedPin === elem.getReading("get-pin").val) {
					falseCounter = 0;
					ftui.setFhemStatus("set "+ elem.data("device") +" "+ elem.data("set") +" off");
					$("#pinpad-text").css({
						"color": elem.data("unlocked-color")
					});
				}
				else{
					falseCounter += 1;
					$("#input-pinpad").addClass("shake-false-pin");
					setTimeout(function(){
						$("#input-pinpad").removeClass("shake-false-pin");
					}, 500);
					if (falseCounter == elem.data("tries")) {
						startTimer();
					}
				}
				insertedPin = "";
				setTimeout(function(){
					$("#input-pinpad").html("");
				}, 500)
				counter = 0;
				setTimeout(function(){
					$(".dots-pinpad").css({
						"background": elem.data("pin-off-color"),
						"transition": "all .5s cubic-bezier(0,1,.5,1)",
						"transform": "scale(.7)"
					});
				}, 500);
			}
        });
        $("#back").on("click", function(){
            insertedPin = insertedPin.substring(0, insertedPin.length -1);
            $(".dots-pinpad:nth-child("+ counter +")").css({
				"background": elem.data("pin-off-color"),
				"transition": "all .5s cubic-bezier(0,1,.5,1)",
				"transform": "scale(.7)"
			});
			counter--;
			if (counter <= 0){
				counter = 0;
			}
        });
        function updateDot(elem, pin){
        	this.pin = pin;
        	$("#input-pinpad").html(pin);
        }
	}
	function init_dots(elem){
		// creating dots in pinpad
		if (elem.hasClass("show-pin")){
			$("#input-pinpad").css({
				"color": elem.data("button-color"),
				"line-height": elem.data("btn-size"),
				"font-size": elem.data("font-size"),
				"letter-spacing": "5px"
			});
		}
		else{
			for(var j= 0; j < elem.getReading("get-pin").val.length; j++){
				var dots = $("<div></div>");
				dots.attr("id", "dot" + j);
				dots.attr("class", "dots-pinpad");
				dots.css({
					"background": elem.data("pin-off-color")
				});
				$("#input-pinpad").append(dots);
			}
		}
		if (elem.getReading("get-pin").val.length === 5){
				$(".dots-pinpad").css({
				"left": "12%"
			});
		}
		else if (elem.getReading("get-pin").val.length === 6){
			$(".dots-pinpad").css({
				"left": "5%"
			});
		}
	}

	function elem_styling(elem){
		var slice = parseInt(elem.data("btn-size")) * (- 0.2) + "px";
		if (elem.hasClass("squared")){
			$("#key-pinpad, #back").css({
				"border-radius": "auto"
			});
			$(".number-pinpad").css({
				"border-radius": "auto"
			});
		}
		else {
			$("#key-pinpad, #back").css({
				"border-radius": elem.data("btn-size")
			});
			$(".number-pinpad").css({
				"border-radius": elem.data("btn-size")
			});
		}
		$("#key-pinpad, #back").css({
			"color": elem.data("button-color"),
			"border": "2px solid "+ elem.data("button-color") +"",
			"width": elem.data("btn-size"),
			"height": elem.data("btn-size"),
			"line-height": elem.data("btn-size"),
			"font-size": elem.data("font-size")
		});
		$(".number-pinpad").css({
			"color": elem.data("button-color"),
			"border": "2px solid "+ elem.data("button-color") +"",
			"height": elem.data("btn-size"),
			"width": elem.data("btn-size"),
			"line-height": parseInt(elem.data("btn-size")) * (- 10),
			"font-size": elem.data("font-size")
		});
	}
	function update(dev, par) {
        // do updates from reading for content
        me.elements.filterDeviceReading('get', dev, par)
            .each(function (index) {
                var elem = $(this);
                var value = elem.getReading('get').val;
                if (value){
                	elem_styling(elem);
                	event_handler(elem);
                }
                if(value === "off"){
                	$("#key-pinpad").on("click", function(){
						ftui.setFhemStatus("set "+ elem.data("device") +" "+ elem.data("set") +" on");
					});
                	$("#pinpad-text").css({
                		"color": elem.data("unlocked-color")
                	});
                	$("#pinpad-text").html(elem.data("text-unlocked"));
                }
                else{
                	$("#pinpad-text").css({
                		"color": elem.data("locked-color")
                	});
                	$("#pinpad-text").html(elem.data("text-locked"));
                }
                
            });

        me.elements.filterDeviceReading('get-pin', dev, par)
            .each(function (index) {
                var elem = $(this);
                var value = elem.getReading('get-pin').val;
                if (value){
                	init_dots(elem);
                }
            });
    }

	var me = $.extend(new Modul_widget(), {
        //override or own public members
        widgetname: 'pinpad',
        init: init,
        update: update,
    });

    return me;
};