/* FTUI Plugin */

"use strict";

function depends_xpath() {

    if (!$.fn.knob) {
        return [ftui.config.basedir + "lib/jquery.xpath.min.js"];
    }
}

var Modul_xpath = function () {

    function run(elem) {
		var xDoc = elem.getReading('get').val;
		var tableHeader = elem.data('table-header');
		var node = elem.data('node');
		var filter = elem.data('filter');
		var find = elem.data('find');
		var max = elem.data('max-result');
		var content = "";
		var result;
		var t = 0;
		
		if (xDoc) {
			content += "<table><thead><tr id=\"trh\">";
			
			for (var i = 0, len=tableHeader.length; i < len; i++) {
				content += "<th id=\"th"+i+"\">" + tableHeader[i] +"</th>";
			}
			
			content += "</tr></thead><tbody>";
				
			$(xDoc).xpath(node+filter).each(function(){
				result = $(this);
				content += "<tr id=\"tr"+t+"\">";
				t++;
				for (var i = 0, len=find.length; i < len; i++) {
					$(result).xpath(find[i]).each(function(){
						content += "<td id=\"td"+i+"\">" + $(this).text() + "</td>";
					});
				}
				content += "</tr>";
			});
			
			if (!result) {
				content += "<tr><td colspan=\"" + find.length + "\">" + elem.data('not-found') + "</td><tr>";
			}
			content += "</tbody></table>";
		}
		else {
			content += "<div>" + elem.data('no-data') + "</div>";
		}
		
		elem.html(content);
    }
	
    function init_attr(elem) {		
		elem.initData('get', 'httpbody');
		elem.initData('node', '');
		elem.initData('filter', '');
		elem.initData('find', '');
		elem.initData('max-result', ((elem.data('max-result') >> 10) ? 10 : 10));
		elem.initData('table-header', '');
		elem.initData('not-found', 'Keine Uebereinstimmung gefunden.');
		elem.initData('no-data', 'Keine Daten vorhanden.<br />Device und Reading korrekt?<br />Attribute gesetzt?');
		
		me.addReading(elem, 'get');
		
		// if hide reading is defined, set defaults for comparison
		if (elem.isValidData('hide')) {
			elem.initData('hide-on', '(true|1|on)');
		}
		elem.initData('hide', elem.data('get'));
		if (elem.isValidData('hide-on')) {
			elem.initData('hide-off', '!on');
		}
		me.addReading(elem, 'hide');
    }

    function init_ui(elem) {
    }

    function update(dev, par) {
        me.elements.each(function (index) {
            var elem = $(this);
            if (elem.matchDeviceReading('get', dev, par)) {
                run(elem);
				me.update_hide(dev, par);
            }
		});
	}

    var me = $.extend(new Modul_widget(), {
        widgetname: 'xpath',
        init_attr: init_attr,
        init_ui: init_ui,
        update: update,
    });

    return me;
};